<script setup lang="ts">
import { usePromotionStore } from '@/stores/promotion'
import type { Promotion } from '@/types/Promotion'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Condition',
    key: 'condition'
  },
  {
    title: 'Start Date',
    key: 'startDate'
  },
  {
    title: 'End Date',
    key: 'endDate'
  },
  {
    title: 'Discount Price',
    key: 'discountPrice'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const usePromotion = usePromotionStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)

async function onSubmit() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await usePromotion.savePromotion()
  closeDialog()
}

async function editItem(item: Promotion) {
  if (!item.id) return
  await usePromotion.getPromotion(item.id)
  dialog.value = true
}
async function deleteItem(item: Promotion) {
  if (!item.id) return
  await usePromotion.getPromotion(item.id)
  dialogDelete.value = true
}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    usePromotion.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await usePromotion.deletePromotion()
  closeDelete()
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    usePromotion.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await usePromotion.savePromotion()
  closeDialog()
}
onMounted(async () => {
  await usePromotion.getPromotions()
})
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="usePromotion.promotions" height="calc(90vh - 200px)">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Promotions</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props"> New Promotion </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Promotion Details</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="usePromotion.editedPromotion.name"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="usePromotion.editedPromotion.condition"
                          class="mb-2"
                          clearable
                          label="Description"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="usePromotion.editedPromotion.startDate"
                          class="mb-2"
                          clearable
                          label="Start Date"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="usePromotion.editedPromotion.endDate"
                          class="mb-2"
                          clearable
                          label="End Date"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="usePromotion.editedPromotion.discountPrice"
                          class="mb-2"
                          clearable
                          label="Discount Price"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>

      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
    </v-data-table>
  </div>
</template>
